import { wx } from './lib/jweixin-1.2.0';
import {objectToUrl, urlToObject} from 'caoh5-util';
import { proRequest } from 'caoh5-request';

const setUid=(obj,config)=>{
  console.log(obj,config);
  if(config.uid===undefined){
    return obj;
  }
  if(!obj.u1){
    obj.u1=config.uid;
  }else if(obj.u1 && !obj.u2){
    obj.u2=config.uid;
  }else if(obj.u1 && obj.u2 && !obj.u3){
    obj.u3=config.uid;
  }
  return obj;
};

const setConfig = (config, type, fq) => {
  let obj = setUid(urlToObject(config.link),config);
  obj.fq = fq;
  wx[type](Object.assign({}, config, {
    link: objectToUrl(config.link.split('?')[0], obj)
  }));
};

const wxShare = function (config, option=[], url='') {
  config = Object.assign({
    title: document.title,
    desc: '',
    link: window.location.href,
    imgUrl: ''
  }, config);

  option = ["onMenuShareTimeline", "onMenuShareAppMessage", "onMenuShareQQ", "onMenuShareQZone"].concat(option);
  proRequest({
    url: url || `https://cap.caocaokeji.cn/cap/bps/wechatShareSign/1.0?clientType=3&clientVersion=1.0&sign=1212&appVersion=12&appCode=no_sign&timestamp=${new Date().getTime()}&url=${window.encodeURIComponent(window.location.href)}`,
    type: 'jsonp'
  }).then(data => {
    if (data.code == '0') {
      var data = data.data;
      wx.config({
        debug: false, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
        appId: data.appId, // 必填，公众号的唯一标识
        timestamp: data.timestamp, // 必填，生成签名的时间戳
        nonceStr: data.nonceStr, // 必填，生成签名的随机串
        signature: data.signature, // 必填，签名，见附录1
        jsApiList: [...option]
      });
      wx.ready(()=>{
        option.forEach(res=>wx[res](config));
        setConfig(config, 'onMenuShareTimeline', 'pyq');
        setConfig(config, 'onMenuShareAppMessage', 'wx');
        setConfig(config, 'onMenuShareQQ', 'qq');
        setConfig(config, 'onMenuShareQZone', 'wb');
      });
      wx.error(function (err) {
        console.log(JSON.stringify(err));
      });
    }
  });
};

export { wxShare };